
#import "NetWorkingApiClient.h"

#define TESTLog(...)  NSLog(__VA_ARGS__)


@implementation NetTool
+ (NSURLSessionDataTask *)Post_AppendURL:(NSString *)appendURL
                              parameters:(NSDictionary *)param
                                 success:(void (^)(id responseObject))success failure:(void (^)(NSError *error))failure{
    NSMutableDictionary *parameters = [[NSMutableDictionary alloc]init];
    [parameters setObject:@"ok" forKey:@"json"];
    if (param != nil) {
        NSString *desString  =  [NSDictionary stitchingStringFromDictionary:param];
        NSString *md5String = [BSPHP_PASSWORD md5:BSPHP_PASSWORD];
        desString = [DES3Util encrypt:desString gkey:md5String];
        desString = [desString URLEncodedString];
        parameters[@"parameter"] = desString;
    }
    return [[NetWorkingApiClient sharedNetWorkingApiClient] POST:appendURL
                                                      parameters:parameters
                                                        progress:nil
                                                         success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
                                                           
                                                             NSString *str = [[NSString alloc]initWithData:responseObject encoding:NSUTF8StringEncoding];
                                                             NSString *md5String = [BSPHP_PASSWORD md5:BSPHP_PASSWORD];
                                                             str = [DES3Util decrypt:str gkey:md5String];
                                                             TESTLog(@"请求网址 = %@",appendURL);
                                                             TESTLog(@"parameters = %@",parameters);
                                                             TESTLog(@"服务器返回数据 = %@",str);
                                                             NSData * data = [str dataUsingEncoding:NSUTF8StringEncoding];
                                                             NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:nil];
                                                             TESTLog(@"dict = %@",dict);
                                                             success(data);
                                                         }
                                                         failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
                                                             TESTLog(@"%@",error);
                                                             failure(error);
                                                         }];
    
}




@end
