//
//  ViewController.m
//  BSPHPOC
//  BSPHP 技术团队
//  Created by MRW on 2016/12/14.
//  Copyright © 2016年 xiaozhou. All rights reserved.
//

#import "ViewController.h"
#import "MainController.h"
@interface ViewController ()
@property (weak, nonatomic) IBOutlet UITextField *cardStringTF;
@property (weak, nonatomic) IBOutlet UILabel *noticeBoardLabel;
@property (nonatomic,strong) NSDictionary * baseDict;//基础字典
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    NSMutableDictionary *param = [NSMutableDictionary dictionary];
    param[@"api"] = @"BSphpSeSsL.in";
    param[@"date"] = [self getSystemDate];
    param[@"md5"] = @"";
    param[@"mutualkey"] = BSPHP_MUTUALKEY;
    __weak typeof(self) weakself = self;
    [NetTool Post_AppendURL:BSPHP_HOST parameters:param success:^(id responseObject) {
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        if (dict) {
            weakself.baseDict = dict;
             [weakself loadAnnouncement];
        }
    } failure:^(NSError *error) {
    }];
}

/**
 加载公告 API
 */
- (void)loadAnnouncement{
    NSMutableDictionary *param = [NSMutableDictionary dictionary];
    param[@"api"] = @"gg.in";
    param[@"BSphpSeSsL"] = self.baseDict[@"response"][@"data"];
    param[@"date"] = [self getSystemDate];
    param[@"md5"] = @"";
    param[@"mutualkey"] = BSPHP_MUTUALKEY;
    
    __weak typeof(self) weakself = self;
    [NetTool Post_AppendURL:BSPHP_HOST parameters:param success:^(id responseObject) {
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        if (dict) {
            weakself.noticeBoardLabel.text = dict[@"response"][@"data"];
        }
    } failure:^(NSError *error) {
        
    }];
}

/**
 验证使用

 @param sender button
 */
- (IBAction)yanzhengAndUseIt:(id)sender {
    if (self.cardStringTF.text.length > 0) {
        NSMutableDictionary *param = [NSMutableDictionary dictionary];
        param[@"api"] = @"login.ic";
        param[@"BSphpSeSsL"] = self.baseDict[@"response"][@"data"];
        param[@"date"] = [self getSystemDate];
        param[@"md5"] = @"";
        param[@"mutualkey"] = BSPHP_MUTUALKEY;
        param[@"icid"] = self.cardStringTF.text;
        param[@"icpwd"] = @"";
         param[@"key"] = [[[UIDevice currentDevice] identifierForVendor] UUIDString];;
         param[@"maxoror"] = [[[UIDevice currentDevice] identifierForVendor] UUIDString];;
        __weak typeof(self) weakself = self;
        [NetTool Post_AppendURL:BSPHP_HOST parameters:param success:^(id responseObject) {
            NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
            if (dict) {
                NSString *dataString = dict[@"response"][@"data"];
                NSRange range = [dataString rangeOfString:@"|1081|"];
                if (range.location != NSNotFound) {
                  MainController *vc =  [[MainController alloc]init];
                    [vc loadData:weakself.baseDict];
                    [weakself.navigationController pushViewController:vc animated:YES];
                }else{
                    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"提示" message:dataString delegate:self cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
                    [alert show];
                }
            }
        } failure:^(NSError *error) {
            
        }];
    }
}

/**
 网络测试

 @param sender button
 */
- (IBAction)netTest:(id)sender {
    NSMutableDictionary *param = [NSMutableDictionary dictionary];
    param[@"api"] = @"internet.in";
    param[@"BSphpSeSsL"] = self.baseDict[@"response"][@"data"];
    param[@"date"] = [self getSystemDate];
    param[@"md5"] = @"";
    param[@"mutualkey"] = BSPHP_MUTUALKEY;
    
    __weak typeof(self) weakself = self;
    [NetTool Post_AppendURL:BSPHP_HOST parameters:param success:^(id responseObject) {
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        if (dict) {
            
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"提示" message:dict[@"response"][@"data"] delegate:weakself cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
            [alert show];
        }
    } failure:^(NSError *error) {
        
    }];
}
   
- (IBAction)versionGet:(id)sender {
    NSMutableDictionary *param = [NSMutableDictionary dictionary];
    param[@"api"] = @"v.in";
    param[@"BSphpSeSsL"] = self.baseDict[@"response"][@"data"];
    param[@"date"] = [self getSystemDate];
    param[@"md5"] = @"";
    param[@"mutualkey"] = BSPHP_MUTUALKEY;
    
    __weak typeof(self) weakself = self;
    [NetTool Post_AppendURL:BSPHP_HOST parameters:param success:^(id responseObject) {
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
        if (dict) {
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"提示" message:dict[@"response"][@"data"] delegate:weakself cancelButtonTitle:@"确定" otherButtonTitles:nil, nil];
            [alert show];
        }
    } failure:^(NSError *error) {
        
    }];
}

- (IBAction)openNews:(UIButton *)sender {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:BSPHP_NEWS]];
}

- (IBAction)feedBacktoUs:(UIButton *)sender {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:BSPHP_BACK]];
}


- (NSString *)getSystemDate{
    NSDate *currentDate = [NSDate date];//获取当前时间，日期
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"YYYY/MM/dd#HH:mm:ss"];
    return [dateFormatter stringFromDate:currentDate];
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.view endEditing:YES];
}

@end
